{ pkgs ? import /nixpkgs {} }:

let
  pythreshold = pkgs.python3Packages.buildPythonPackage rec {
    pname = "pythreshold";
    version = "0.3.1";

    propagatedBuildInputs = with pkgs.python3Packages; [
      numpy
      scipy
      scikitimage
      matplotlib
      pkgs.python3Packages.opencv4
    ];
    src = pkgs.python3Packages.fetchPypi {
      inherit pname version;
      sha256 = "149f4dkx6dm8rlh3disas9xpr13cfglpkrqfx2manaahgwkgpx12";
    };
    preBuild = ''
      substituteInPlace setup.py --replace "'opencv-python'" ""
    '';
  };
in pkgs.mkShell rec {
  name = "ColonyCounter";
  version = "0.1";

  pyEnv = pkgs.python38.withPackages (ps: with pkgs.python3Packages; [
    numpy
    pandas
    pythreshold
    scikitimage
    scipy
    opencv4
  ]);

  nativeBuildInputs = [ pyEnv ];
}
